/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;

/**
 * 16i_vs[eBeBNX<BR>
 * JsĂ sӂɂf[^16i_vȂ܂B
 * ̃NX ̂悤16i_vsNXłB
 * Ȃ _vo͂̂̂ wx ōs܂B
 *
 * @author Tosiki IGA , Eiichirou Takahashi
 */
public class HexDumpUtil
{
	/**
	 * ^ꂽ16i_v񉻂܂B
	 *
	 * @param String strDump _v
	 * @return String 16iꂽ_v
	 */
	public static final String toString(String strDump)
	{
		try{
			StringWriter writerBuf=new StringWriter();
			HexDumpWriter writer=new HexDumpWriter(writerBuf);
			writer.write(strDump);
			writer.flush();
			writer.close();
			return writerBuf.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽ16i_v񉻂܂B
	 *
	 * @param byte[] bytearyDump _vbytez
	 * @return String 16iꂽ_v
	 */
	public static final String toString(byte[] bytearyDump)
	{
		try{
			StringWriter writerBuf=new StringWriter();
			HexDumpWriter writer=new HexDumpWriter(writerBuf);
			writer.write(bytearyDump);
			writer.flush();
			writer.close();
			return writerBuf.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}
}

