/**
 * IgaLib -> wizard
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.wizard;

import jp.ne.nifty.iga.tosiki.string.IndentWriter;
import java.io.*;

/**
 * JSourceCodeWizardProcessor ̃wp[NX<BR>
 * MojiUtil̎荞ݕł<BR>
 *
 * @author Tosiki IGA
 */
public class JSourceCodeWizardProcessorMojiUtil
{
	/**
	 * trimRight()  0ɂȂ̂ȂtrimRight()}XCb`B
	 */
	public static final boolean TRIAL_ADDITIONAL_TRIM_RIGHT=false;

	/**
	 * ʊ֐΂Ƒ}܂B
	 * ̏ꏊg GȂłB
	 */
	public static final void writeMojiUtil(
		IndentWriter out)
		throws IOException
	{
		// 牺͈̔͂ɓ\t

		out.println("	/**");
		out.println("	 * ^ꂽ\Ȍ萔܂B<BR>");
		out.println("	 * ̃\bh͔p̂ݗLłB");
		out.println("	 * P̃eXgĂ݂ƂAInteger.parseInt()͑Sp");
		out.println("	 * Ă܂ (܂ ̂߂ǂłp\) ͗lłB(at JDK1.3.1)");
		out.println("	 * ");
		out.println("	 *   @param String strInput ͕");
		out.println("	 *   @return int oꂽ");
		out.println("	 */");
		out.println("	public static final int toInteger(String strInput)");
		out.println("	{");
		out.println("		if(strInput==null");
		out.println("		|| strInput.length()==0)");
		out.println("		{");
		out.println("			return 0;");
		out.println("		}");
		out.println("		try{");
		out.println("			return Integer.parseInt(strInput);");
		out.println("		}catch(java.lang.NumberFormatException ex){");
		out.println("			return 0;");
		out.println("		}");
		out.println("	}");
		out.println("");
		out.println("	/**");
		out.println("	 * ^ꂽw蒷ɂ҂Ɏ܂悤H郁\bh<BR>");
		out.println("	 * 2oCg1̕2ƂăJEg܂B<BR>");
		out.println("	 * yӁz̃\bhɂĂ JSourceCodeWizardNX쐬ЂȌ`\[XR[h");
		out.println("	 * ̈ꕔƂėp܂BƂ͂̂ق ǂ낵肢܂B<BR>");
		out.println("	 * <BR>");
		out.println("	 * ȂA݂̎ł EUCɂĔpJ^Ji2oCgɂȂ錏ɂđΉĂ܂<BR>");
		out.println("	 * ");
		out.println("	 *   @param String strInput ͕");
		out.println("	 *   @param int iLength ");
		out.println("	 *   @param char cFill ߂镶");
		out.println("	 *   @return String ");
		out.println("	 */");
		out.println("	public static final String fitRight(String strInput,int iLength,char cFill)");
		out.println("	{");
		out.println("		try{");
		out.println("			StringReader reader=new StringReader(strInput);");
		out.println("			StringWriter writer=new StringWriter();");
		out.println("			for(int iCurrentLength=0;;)");
		out.println("			{");
		out.println("				int iRead=reader.read();");
		out.println("				if(iRead<0)break;");
		out.println("				if(iRead>0xff)");
		out.println("				{");
		out.println("					iCurrentLength+=2;");
		out.println("				}");
		out.println("				else");
		out.println("				{");
		out.println("					iCurrentLength+=1;");
		out.println("				}");
		out.println("				if(iCurrentLength<=iLength)");
		out.println("				{");
		out.println("					writer.write(iRead);");
		out.println("				}");
		out.println("				else");
		out.println("				{");
		out.println("					break;");
		out.println("				}");
		out.println("			}");
		out.println("			reader.close();");
		out.println("			writer.flush();");
		out.println("			writer.close();");
		out.println("			return padRight(writer.toString(),iLength,cFill);");
		out.println("		}catch(IOException ex){");
		out.println("			System.out.println(ex.toString());");
		out.println("			ex.printStackTrace();");
		out.println("			return null;");
		out.println("		}");
		out.println("	}");
		out.println("");
		out.println("	/**");
		out.println("	 * ^ꂽw蒷܂ŉEɎw蕶𖄂߂郁\bh<BR>");
		out.println("	 * 2oCg1̕2ƂăJEg܂B<BR>");
		out.println("	 * yӁz̃\bhɂĂ JSourceCodeWizardNX쐬ЂȌ`\[XR[h");
		out.println("	 * ̈ꕔƂėp܂BƂ͂̂ق ǂ낵肢܂B<BR>");
		out.println("	 * ");
		out.println("	 *   @param String strInput ͕");
		out.println("	 *   @param int iLength ");
		out.println("	 *   @param char cFill ߂镶B");
		out.println("	 *   @return String ");
		out.println("	 */");
		out.println("	public static final String padRight(String strInput,int iLength,char cFill)");
		out.println("	{");
		out.println("		try{");
		out.println("			int iInputLength=strInput.getBytes().length;");
		out.println("");
		out.println("			StringWriter writer=new StringWriter();");
		out.println("			writer.write(strInput);");
		out.println("");
		out.println("			for(int iCurrentLength=iInputLength;;)");
		out.println("			{");
		out.println("				if(cFill>0xff)");
		out.println("				{");
		out.println("					iCurrentLength+=2;");
		out.println("					if(iCurrentLength>iLength)");
		out.println("					{");
		out.println("						if(iCurrentLength==(iLength+1))");
		out.println("						{");
		out.println("							writer.write(' ');");
		out.println("						}");
		out.println("						break;");
		out.println("					}");
		out.println("				}");
		out.println("				else");
		out.println("				{");
		out.println("					iCurrentLength+=1;");
		out.println("				}");
		out.println("");
		out.println("				if(iCurrentLength<=iLength)");
		out.println("				{");
		out.println("					writer.write(cFill);");
		out.println("				}");
		out.println("				else");
		out.println("				{");
		out.println("					break;");
		out.println("				}");
		out.println("			}");
		out.println("");
		out.println("			writer.flush();");
		out.println("			writer.close();");
		out.println("");
		out.println("			return writer.toString();");
		out.println("		}catch(IOException ex){");
		out.println("			System.out.println(ex.toString());");
		out.println("			ex.printStackTrace();");
		out.println("			return null;");
		out.println("		}");
		out.println("	}");
		out.println("");
		out.println("	/**");
		out.println("	 * ^ꂽ̉E؂߂郁\bh");
		out.println("	 * p󔒂ƑSp󔒂؂߂܂");
		out.println("	 * yӁz̃\bhɂĂ JSourceCodeWizardNX쐬ЂȌ`\[XR[h");
		out.println("	 * ̈ꕔƂėp܂BƂ͂̂ق ǂ낵肢܂B<BR>");
		out.println("	 * ");
		out.println("	 *   @param String strInput ͕");
		out.println("	 *   @return String ؂ߌ㕶");
		out.println("	 */");
		out.println("	public static final String trimRight(String strInput)");
		out.println("	{");
		if(TRIAL_ADDITIONAL_TRIM_RIGHT)out.println("		if(strInput.trim().length()==0)return strInput;");
		out.println("		try{");
		out.println("			StringReader reader=new StringReader(strInput);");
		out.println("			StringWriter writer=new StringWriter();");
		out.println("			StringBuffer strbufWhiteSpace=new StringBuffer();");
		out.println("");
		out.println("			for(;;)");
		out.println("			{");
		out.println("				int iRead=reader.read();");
		out.println("				if(iRead<0)break;");
		out.println("				if(iRead==' '");
		out.println("				|| iRead=='@')");
		out.println("				{");
		out.println("					strbufWhiteSpace.append((char)iRead);");
		out.println("				}");
		out.println("				else");
		out.println("				{");
		out.println("					writer.write(strbufWhiteSpace.toString());");
		out.println("					strbufWhiteSpace=new StringBuffer();");
		out.println("					writer.write(iRead);");
		out.println("				}");
		out.println("			}");
		out.println("");
		out.println("			reader.close();");
		out.println("			writer.flush();");
		out.println("			writer.close();");
		out.println("");
		out.println("			return writer.toString();");
		out.println("		}catch(IOException ex){");
		out.println("			System.out.println(ex.toString());");
		out.println("			ex.printStackTrace();");
		out.println("			return null;");
		out.println("		}");
		out.println("	}");
		out.println("");
		out.println("	/**");
		out.println("	 * ^ꂽ̈ꕔ擾郁\bh");
		out.println("	 * 2oCg1̕2ƂăJEg܂B");
		out.println("	 * UnicodeIȓ͍s܂B");
		out.println("	 * rŕfꍇ ̕͏Ȃ p󔒂𖄂߂܂B<BR>");
		out.println("	 * yӁz̃\bhɂĂ JSourceCodeWizardNX쐬ЂȌ`\[XR[h");
		out.println("	 * ̈ꕔƂėp܂BƂ͂̂ق ǂ낵肢܂B<BR>");
		out.println("	 * ");
		out.println("	 *   @param String strInput ͕");
		out.println("	 *   @param int iStart Jnʒu (0IW)");
		out.println("	 *   @param int iLength 擾");
		out.println("	 *   @return String ");
		out.println("	 */");
		out.println("	public static final String subString(String strInput,int iStart,int iLength)");
		out.println("	{");
		out.println("		if(strInput==null)return null;");
		out.println("		if(iLength<=0)return \"\";");
		out.println("		try{");
		out.println("			StringReader reader=new StringReader(strInput);");
		out.println("			StringWriter writer=new StringWriter();");
		out.println("			int iTotalLength=0;");
		out.println("			// X^[gn_܂ő");
		out.println("			for(int iCurrentLength=0;iCurrentLength<iStart;)");
		out.println("			{");
		out.println("				int iRead=reader.read();");
		out.println("				if(iRead<0)");
		out.println("				{");
		out.println("					// X^[gn_ɓ͂OɏI");
		out.println("					return \"\";");
		out.println("				}");
		out.println("				if(iRead>0xff)");
		out.println("				{");
		out.println("					iCurrentLength+=2;");
		out.println("					if(iCurrentLength>=iStart)");
		out.println("					{");
		out.println("						if(iCurrentLength>iStart)");
		out.println("						{");
		out.println("							writer.write(' ');");
		out.println("							iTotalLength++;");
		out.println("						}");
		out.println("						break;");
		out.println("					}");
		out.println("				}");
		out.println("				else");
		out.println("				{");
		out.println("					iCurrentLength+=1;");
		out.println("				}");
		out.println("			}");
		out.println("			// w蒷ǂ݂Ƃ");
		out.println("			for(;iTotalLength<iLength;)");
		out.println("			{");
		out.println("				int iRead=reader.read();");
		out.println("				if(iRead<0)break;");
		out.println("				if(iRead>0xff)");
		out.println("				{");
		out.println("					iTotalLength+=2;");
		out.println("					if(iTotalLength>iLength)");
		out.println("					{");
		out.println("						writer.write(' ');");
		out.println("						break;");
		out.println("					}");
		out.println("				}");
		out.println("				else");
		out.println("				{");
		out.println("					iTotalLength+=1;");
		out.println("				}");
		out.println("");
		out.println("				writer.write(iRead);");
		out.println("			}");
		out.println("			writer.flush();");
		out.println("			writer.close();");
		out.println("			return writer.toString();");
		out.println("		}catch(IOException ex){");
		out.println("			System.out.println(ex.toString());");
		out.println("			ex.printStackTrace();");
		out.println("			return null;");
		out.println("		}");
		out.println("	}");

		// ܂ł͈̔͂ɓ\t

		out.println("");
	}
}

