/**
 * \ Member (o[) ɑ΂f[^ANZXNX̃eXg<BR>
 * Copyright (C) 2001 Copyright (C) 2001 ɉq<BR>
 * 
 * @author ɉq
 */

import java.io.*;
import java.sql.*;
import java.util.*;

public class DataMemberTest
{
	public static final void main(String[] args)
	{
		try{
			Connection conn=MyConnection.getConnection();
			DataMember member=new DataMember();

			try{
				dropTable(conn,member);
			}catch(Exception ex){
				;
			}

			createTable(conn,member);
			insertInto(conn,member);

			member=new DataMember();

			PreparedStatement stmt=member.sqlSelect(conn);
			ResultSet resultSet=stmt.executeQuery();
			for(;resultSet.next();)
			{
				member.parse(resultSet);
				System.out.println(member.getDisplayString());
			}
			resultSet.close();
			stmt.close();

			{
				BufferedWriter writer=new BufferedWriter(new OutputStreamWriter(new FileOutputStream("DataMemberTest.tab")));
				ArrayList vecResult=DataMember.sqlSelectList(conn);
				for(int index=0;index<vecResult.size();index++)
				{
					DataMember member2=(DataMember)vecResult.get(index);
					member2.serializeTsv(writer);
					writer.newLine();
				}
				writer.flush();
				writer.close();
			}

			{
				BufferedWriter writer=new BufferedWriter(new OutputStreamWriter(new FileOutputStream("DataMemberTest.csv")));
				ArrayList vecResult=DataMember.sqlSelectList(conn);
				for(int index=0;index<vecResult.size();index++)
				{
					DataMember member2=(DataMember)vecResult.get(index);
					member2.serializeCsv(writer);
					writer.newLine();
				}
				writer.flush();
				writer.close();
			}

			{
				System.out.println("CWHERE ORDEReXg:Jn");
				PreparedStatement stmt2=member.sqlSelectWhereOrderBy(conn,null,null,"membersName");
				ResultSet resultSet2=stmt2.executeQuery();
				for(;resultSet2.next();)
				{
					member.parse(resultSet2);
					System.out.println(member.getDisplayString());
				}
				resultSet2.close();
				stmt2.close();
				System.out.println("CWHERE ORDEReXg:I");
			}

			{
				System.out.println("CWHERE ORDEReXg2:Jn");
				PreparedStatement stmt2=member.sqlSelectWhereOrderBy(conn,"memberCode=?",new Object[]{member.fitRight("10002",member.getMemberCodeLength(),' ')},"age");
				ResultSet resultSet2=stmt2.executeQuery();
				for(;resultSet2.next();)
				{
					member.parse(resultSet2);
					System.out.println(member.getDisplayString());
				}
				resultSet2.close();
				stmt2.close();
				System.out.println("CWHERE ORDEReXg2:I");
			}

			deleteFrom(conn);

			member=member.sqlSelect(conn,"10002");
			member.setMembersName("VO");
			member.sqlUpdate(conn);

			ArrayList vecResult=DataMember.sqlSelectList(conn);
			for(int index=0;index<vecResult.size();index++)
			{
				DataMember member2=(DataMember)vecResult.get(index);
				System.out.println("ArrayList:"+member2.getDisplayString());
			}

			//dropTable(conn,member);

			conn.close();
		}catch(Exception ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
		}
	}

	public static final void createTable(Connection conn,DataMember member)
		throws SQLException
	{
		member.sqlCreateTable(conn);
	}

	public static final void dropTable(Connection conn,DataMember member)
		throws SQLException
	{
		member.sqlDropTable(conn);
	}

	public static final void insertInto(Connection conn,DataMember member)
		throws SQLException
	{
		member.setMemberCode("10001");
		member.setMembersName("ӂ΂");
		member.setAge(55);
		//member.setIncome(new java.math.BigDecimal("12345.678"));
		System.out.println("}O:"+member.getDisplayString());
		if(member.sqlInsertInto(conn)==1)
		{
			System.out.println("DB\}");
		}

		member.setMemberCode("10002");
		member.setMembersName("");
		member.setAge(32);
		System.out.println("}O:"+member.getDisplayString());
		if(member.sqlInsertInto(conn)==1)
		{
			System.out.println("DB\}");
		}
	}

	public static final void deleteFrom(Connection conn)
		throws SQLException
	{
		DataMember member=DataMember.sqlSelect(conn,"10001");
		int iRet=member.sqlDelete(conn);
		if(iRet!=1)
		{
			System.out.println("s̍폜Ɏs܂B");
		}
		else
		{
			System.out.println("s̍폜ɐ܂B");
		}
	}
}
