/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import java.io.*;

/**
 * SẴNXeXgNXłB<BR>
 * JUnit𗘗păeXg{邽߂ɑ݂NXłB
 * ̃NXg̗prɗp邱Ƃ͖ł傤B<BR>
 * VJUniteXgR[hǉꍇɂ́ÃNXɐVNXǋL܂B
 *
 * @author Tosiki IGA
 */
public class AllTest
	extends TestCase
{
	public AllTest(String name)
	{
		super(name);
	}

	public static Test suite()
	{
		TestSuite suite=new TestSuite(ZenkakuTest.class);
		suite.addTest(new TestSuite(HexDumpTest.class));
		suite.addTest(new TestSuite(MojiUtilTest.class));

		suite.addTest(new TestSuite(jp.ne.nifty.iga.tosiki.wizard.JSourceCodeWizardTest.class));

		return suite;
	}
}


